<template>
  <section class="container">
    <div ref="parent" class="canvas-wrapper">
      <img
        class="fighting-salesman"
        src="~/static/fight_images/salesman.png"
        alt="salesman"
      />
      <img
        class="fighting-loon"
        src="~/static/fight_images/loon.png"
        alt="loon"
      />

      <transition name="fade">
        <span v-if="overlay" class="fight-overlay">{{ overlay }}</span>
      </transition>
    </div>
  </section>
</template>

<script>
import Game from '~/phaser/game'
import SchniSchnaSchnu from '~/phaser/schni_schna_schnu-scene'
import HpScene from '~/phaser/hp-scene'

import { createNamespacedHelpers } from 'vuex'

const storeModules = {
  fight: createNamespacedHelpers('fight'),
  map: createNamespacedHelpers('map'),
  player: createNamespacedHelpers('player')
}

export default {
  data() {
    return {
      overlay: 'Fight!'
    }
  },

  computed: {
    ...storeModules.fight.mapState(['enemyName']),
    ...storeModules.player.mapState(['scissorLevel', 'paperLevel', 'rockLevel'])
  },

  mounted() {
    const { parent } = this.$refs
    const baseUrl = this.$router.options.base
    this.game = new Game({ parent })

    // create Scenes
    const myHpScene = new HpScene({
      x: 500,
      y: 50,
      width: 150,
      height: 20,
      lineWidth: 2,
      maxValue: 100,
      key: 'myHpScene'
    })
    myHpScene.setCurrentValue(100)
    const enemyHpScene = new HpScene({
      x: 50,
      y: 50,
      width: 150,
      height: 20,
      lineWidth: 2,
      maxValue: 100,
      key: 'enemyHpScene'
    })
    enemyHpScene.setCurrentValue(100)

    const { scissorLevel, paperLevel, rockLevel } = this
    const mySchniSchnaSchnu = new SchniSchnaSchnu({
      baseUrl: baseUrl,
      key: 'schniSchnaSchnu',
      endFight: this.endFight,
      scissorLevel,
      paperLevel,
      rockLevel
    })

    // add Scenes
    this.game.scene.add(null, mySchniSchnaSchnu, true)
    this.game.scene.add(null, myHpScene, true)
    this.game.scene.add(null, enemyHpScene, true)

    setTimeout(() => {
      this.overlay = null
    }, 500)
  },

  beforeDestroy() {
    this.game.destroy()
  },

  methods: {
    ...storeModules.map.mapActions(['hideLayer']),
    ...storeModules.player.mapActions(['reduceHearts']),

    endFight(hasPlayerWon) {
      if (hasPlayerWon) {
        this.overlay = 'You won!'
        setTimeout(() => {
          this.hideLayer(this.enemyName)
        }, 2000)
      } else {
        this.overlay = 'You lost!'
        setTimeout(() => {
          this.reduceHearts(1)
        }, 2000)
      }

      setTimeout(() => {
        this.$router.push('/shadow-world')
      }, 1000)
    }
  }
}
</script>

<style>
.container {
  position: absolute;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  display: flex;
}

.canvas-wrapper {
  position: relative;
  margin: auto;
  padding: 21px;
}

.fighting-salesman,
.fighting-loon {
  height: 600px;
  position: absolute;
  top: 0;
}

.fighting-loon {
  right: -350px;
}

.fighting-salesman {
  left: -250px;
}

.fight-overlay {
  font-size: 96px;
  color: red;
  text-shadow: 0 0 4px black;
  position: absolute;
  top: 50%;
  left: 50%;
  width: 400px;
  height: 100px;
  margin-left: -200px;
  margin-top: -50px;
  text-align: center;
}
</style>
